include:
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: License-Scanning.gitlab-ci.yml
  - template: SAST.gitlab-ci.yml

stages:
  - prepare:node
  - test
  - build
  - publish

cache:
  key: "$CI_COMMIT_REF_SLUG" # contains either the branch or the tag, so it's caching per branch
  policy: pull
  paths:
    - "node_modules/"

setup_node_deps:
  image: node:10-alpine
  stage: prepare:node
  cache:
    key: "$CI_COMMIT_REF_SLUG" # contains either the branch or the tag, so it's caching per branch
    untracked: true
    policy: push
    paths:
      - "node_modules/"
  script:
    - apk --no-cache add --virtual builds-deps build-base python && npm install && apk del builds-deps

unit_tests:
  image: node:10-alpine
  stage: test
  dependencies:
    - setup_node_deps
  script:
    - npm run test:coverage
  coverage: /All files[^|]*\|[^|]*\s+([\d\.]+)/
  artifacts:
    paths:
      - coverage/lcov-report/
      - build
      - js
  allow_failure: true

build:
  image: node:10-alpine
  stage: build
  dependencies:
    - unit_tests
  script:
    - npm run compile && npm run build
  artifacts:
    paths:
      - coverage/lcov-report/
      - build
      - js

package:
  image: node:10-alpine
  stage: publish
  dependencies:
    - build
  before_script:
    - echo '//registry.npmjs.org/:_authToken=${NPM_TOKEN}'> ~/.npmrc
  script:
    - npm publish --access public
  only:
    - master

pages:
  image: alpine
  stage: publish
  cache: {}
  dependencies:
    - build
  script:
    - mkdir -p public
    - mv coverage/lcov-report public/coverage
  artifacts:
    paths:
      - public
    expire_in: 1 years
  only:
    - master
